unit GDIPPieDemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, AdvChartView, AdvChartGDIP, AdvChartViewGDIP, Math, AdvChart, jpeg,
  StdCtrls, ExtCtrls, AdvChartPaneEditorGDIP, AdvChartPaneEditor,
  AdvChartSerieEditor, Menus, ExtDlgs;

type
  TForm19 = class(TForm)
    AdvGDIPChartView1: TAdvGDIPChartView;
    procedure FormCreate(Sender: TObject);
    procedure AdvGDIPChartView1PieLegendClick(Sender: TObject; Pane, Serie, PointIndex: Integer);
    procedure AdvGDIPChartView1SliceGetValue(Sender: TObject; Serie: integer;
    legendtext: String; value: Double; valuepointindex: integer;
    var valueposition: TPoint; var valuestring: String);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form19: TForm19;

implementation

{$R *.dfm}


procedure TForm19.AdvGDIPChartView1SliceGetValue(Sender: TObject; Serie: integer;
    legendtext: String; value: Double; valuepointindex: integer;
    var valueposition: TPoint; var valuestring: String);
begin
  valuestring := valuestring + ' (' + FloatToStr(value) + ')';
end;

procedure TForm19.AdvGDIPChartView1PieLegendClick(Sender: TObject; Pane, Serie, PointIndex: Integer);
begin
  AdvGDIPChartView1.Panes[0].Series[0].SelectedIndex :=  PointIndex;
end;

procedure TForm19.FormCreate(Sender: TObject);
const
  colors1: array[0..4] of TColor = (clRed, clBlue, clGreen, clPurple, clMaroon);
  colors2: array[0..4] of TColor = (clDkGray, clLtGray, clLime, clOlive, clLime);
  colors3: array[0..4] of TColor = (clBlue, clLime, clFuchsia, clAqua, clRed);
  values: array[0..9] of String = ('Mercedes', 'Audi', 'Land rover', 'BMW', 'Ferrari', 'Bugatti', 'Porsche', 'Range rover', 'Lamborghini', 'Rolls Royc       ');
begin

  AdvGDIPChartView1.Panes[0].Series[0].AddPiePoints(1979, values[0], colors2[0], Colors3[0], 0, true);
  AdvGDIPChartView1.Panes[0].Series[0].AddPiePoints(569, values[1], colors2[1], Colors3[1], 0, true);
  AdvGDIPChartView1.Panes[0].Series[0].AddPiePoints(29, values[2], colors2[2], Colors3[2], 0, true);
  AdvGDIPChartView1.Panes[0].Series[0].AddPiePoints(17, values[3], colors2[3], Colors3[3], 0, true);
  AdvGDIPChartView1.Panes[0].Series[0].AddPiePoints(16, values[4], colors2[4], Colors3[4], 0, true);
  AdvGDIPChartView1.Panes[0].Series[0].AddPiePoints(13, values[5], colors2[0], Colors3[0], 0, true);
  AdvGDIPChartView1.Panes[0].Series[0].AddPiePoints(11, values[6], colors2[1], Colors3[1], 0, true);
  AdvGDIPChartView1.Panes[0].Series[0].AddPiePoints(8, values[7], colors2[2], Colors3[2], 0, true);

  AdvGDIPChartView1.Panes[0].Series[0].ChartType := ctDonut;

  AdvGDIPChartView1.Panes[0].Series[0].Pie.LegendGradientType := gtHatch;
  AdvGDIPChartView1.Panes[0].Series[0].Pie.LegendHatchStyle := HatchStyleForwardDiagonal;
  AdvGDIPChartView1.Panes[0].Series[0].Pie.LegendOpacity := 100;
  AdvGDIPChartView1.Panes[0].Series[0].Pie.LegendOpacityTo := 100;

  AdvGDIPChartView1.Panes[0].Series[0].Pie.ValueFont.Color := clBlack;

  AdvGDIPChartView1.Panes[0].Series[0].Pie.ValuePosition := vpOutSideSlice;

  AdvGDIPChartView1.Panes[0].Series[0].OnSerieSliceGetValue := AdvGDIPChartView1SliceGetValue;

  AdvGDIPChartView1.Panes[0].Series[0].BorderColor := clWhite;

  AdvGDIPChartView1.Panes[0].Series[0].Pie.Size := 80;
  AdvGDIPChartView1.Panes[0].Series[0].Pie.InnerSize := 55;
end;


end.
